/*
Teegi nimi       : utils.cpp
Autor            : Erki Suurjaak
Loodud           : 30.12.1999
Viimati muudetud : 13.01.2000


 Mitmesuguste kasulike tpide ja funktsioonide teek.
 Sisalduvad tbid :

     bool
                           Tevrtustp. true == 1, false == 0



 Sisalduvad funktsioonid :

     bool IsDate (char *)
                           Kontrollib muutuja sobivust kuupevaks. Muutuja
                           on kujul AAAAKKPP

     bool IsTime (char *)
                           Kontrollib muutuja sobivust kellaajaks. Muutuja
                           on kujul TTMM.

     bool IsLongTime (char *)
                           Kontrollib muutuja sobivust sekunditega kellaajaks.
                           Muutuja on kujul TTMMSS.

     void FatalError (char *)
                           Kirjutab char * -i cerr-i ja vljub programmist
                           errorleveliga 1.


*/
#include <string.h>
#include <stdlib.h>
#include <iostream.h>

typedef signed char bool;     // Tevrtustp. Tene = 1, vr = 0
const bool true  = 1;          // Peaks olema kompatiibel ka uuemate
const bool false = 0;          // kompilaatoritega

// Et kontrollida, kas numbrilistes vrtustes muid asju pole
static const char * const utilsNumberMask = "0123456789";



// Kontrollib, kas Date kvalifitseerub kuupevaks
// Kui kvalifitseerub, siis on vrtuseks 1 (true), kui ei, siis 0 (false)
// Nuded : et kvalifitseeruks, peab Date olema kujul AAAAKKPP. Midagi
// ei tohi ra jtta ega juurde panna.
// Lisaks veel kontrollitakse kuude vrtusi, pevade vrtusi kuude jrgi
// ja kui tegu on 29. veebruariga, siis ka seda, kas tegu ikka on liigaastaga
const bool IsDate (const char * const Date)
{
 if (strlen(Date) != 8) return 0;         // Kige primitiivsem kontroll
 for (int i = 0; i < 8; i++)              // Algne string on lbutu
     if (!strchr (utilsNumberMask, Date[i])) return 0;

 char * tmp = new char[5];
 strncpy (tmp, Date, 4);
 tmp[4] = '\0';
 int Year = atoi (tmp);
 strncpy (tmp, Date + 4, 2);
 tmp[2] = '\0';
 int Month = atoi (tmp);
 strncpy (tmp, Date + 6, 2);
 tmp[2] = '\0';
 int Day = atoi (tmp);
 delete (tmp);

 if (Month < 1 || Month > 12 || Day < 1) return 0;

 if (Year == 0) return 0; // Aastat 0 polnud olemas
 switch (Month)
  {
  case  1 : if (Day > 31) return 0;
            break;
  case  2 : if (Day < 29) break;  // 1400
            if (Day > 29) return 0;
            if (Day == 29)
              {
              if (Year % 100 == 0)              // Kui sajandivahetus,
                 if (Year % 400 != 0) return 0; // peavad sajandid jaguma 4-ga
                 else break;

              if (Year % 4 != 0) return 0;      // Tavaline liigaasta
              break;
              }
            break;
  case  3 : if (Day > 31) return 0;
            break;
  case  5 : if (Day > 31) return 0;
            break;
  case  7 : if (Day > 31) return 0;
            break;
  case  8 : if (Day > 31) return 0;
            break;
  case 10 : if (Day > 31) return 0;
            break;
  case 12 : if (Day > 31) return 0;
            break;
  default : if (Day > 30) return 0; // Kikides muudes kuudes on 30 peva
  }
 return 1;              // Kui siia juti, siis oli ilmselt kik korras
}



// Kontrollib, kas Time kvalifitseerub kellaajaks
// Kui kvalifitseerub, siis on vrtuseks 1 (true), kui ei, siis 0 (false)
// Nuded : et kvalifitseeruks, peab Time olema kujul TTMM. Midagi
// ei tohi ra jtta ega juurde panna.
// Lisaks veel kontrollitakse tundide ja minutite vrtusi.
// Tunnid on 00..23, minutid on 00..59
const bool IsTime (const char * const Time)
{
 if (strlen(Time) != 4) return 0;         // Kige primitiivsem kontroll
 for (int i = 0; i < 4; i++)              // Algne string on lbutu
     if (!strchr (utilsNumberMask, Time[i])) return 0;

 int Number = atoi (Time);
 if (Number / 100 > 23) return 0;         // Siin juba konkreetse sisu jrgi
 if (Number % 100 > 59) return 0;
 return 1;
}



// Kontrollib, kas Time kvalifitseerub sekunditega kellaajaks
// Kui kvalifitseerub, siis on vrtuseks 1 (true), kui ei, siis 0 (false)
// Nuded : et kvalifitseeruks, peab Time olema kujul TTMMSS. Midagi
// ei tohi ra jtta ega juurde panna.
// Lisaks veel kontrollitakse tundide, minutite ja sekundite vrtusi.
// Tunnid on 00..23, minutid on 00..59, sekundid on 00..59
const bool IsLongTime (const char * const Time)
{
 if (strlen(Time) != 6) return 0;         // Kige primitiivsem kontroll
 for (int i = 0; i < 6; i++)              // Algne string on lbutu
     if (!strchr (utilsNumberMask, Time[i])) return 0;

 long Number = atol (Time);
 if (Number / 10000 > 23)       return 0; // Siin juba konkreetse sisu jrgi
 if ((Number / 100) % 100 > 59) return 0;
 if (Number % 100 > 59)         return 0;
 return 1;
}


void FatalError (const char * Message)
{
 if (cerr) cerr << Message;
 exit (1);
}


